#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>

using namespace std;

bool in(int val, vector<int>& vec)
{
    int idx = lower_bound(vec.begin(), vec.end(), val) - vec.begin();
    if (idx == vec.size())
        return false;
    return vec[idx] == val;
}

int main()
{
    int n;
    cin >> n;
    vector<int> data(n);
    for (int i = 0; i < n; ++i)
        cin >> data[i];
    sort(data.begin(), data.end());
    int max_len = 0, ans_d, ans_start;
    for (int d = 1; d < 1000; ++d)
    {
        for (int start = 0; start < n; ++start)
        {
            int next = lower_bound(data.begin(), data.end(), data[start] + d) - data.begin(), curr = 1;
            if (data[next] != data[start] + d)
                continue;
            bool ok = true;
            while (next < n && ok)
            {
                int prev = data[next];
                next = lower_bound(data.begin(), data.end(), data[next] + d) - data.begin();
                if (data[next] != prev + d)
                    ok = false;
                curr++;
            }
            if (curr > max_len)
            {
                max_len = curr;
                ans_d = d;
                ans_start = start;
            }
        }
    }
    vector<int> path;
    path.push_back(ans_start);
    int next = lower_bound(data.begin(), data.end(), data[ans_start] + ans_d) - data.begin();
    bool ok = true;
    while (next < n && ok)
    {
        path.push_back(next);
        int prev = data[next];
        next = lower_bound(data.begin(), data.end(), data[next] + ans_d) - data.begin();
        if (data[next] != prev + ans_d)
            ok = false;
    }
    vector<int> ost;
    for (int i = 0; i < n; ++i)
        if (!in(i, path))
            ost.push_back(i);
    int part = ost.size() / path.size();
    if (ost.size() % path.size() != 0)
        part++;

    vector<int> ans;
    for (int i = 0; i < path.size(); ++i)
    {
        ans.push_back(path[i]);
        for (int j = 0; j < part; ++j)
            if (i * part + j < ost.size())
                ans.push_back(ost[i * part + j]);
    }
    for (int i = 0; i < ans.size(); ++i)
        cout << data[ans[i]] << endl;
    return 0;
}
