#include <bits/stdc++.h>

#define len(a) (int)a.size()
#define all(a) a.begin(), a.end()
#define inout0 cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(false)

using namespace std;

struct node {
    node *l, *r, *p;
    int key, sz;
    node(int k, node *par = nullptr) : key(k), p(par) {
        l = r = nullptr;
        sz = 1;
    }
};

ostream& operator<< (ostream &out, node *root) {
    if (!root) return out;
    out << root->l << root->key << " " << root->r;
    return out;
}

void get_key(node *root) {
    if (!root) cout << "-";
    else cout << root->key;
}

void print(node *root) {
    cout << "NODE = " << root->key << " l = ";
    get_key(root->l);
    cout << " r = ";
    get_key(root->r);
    cout << " p = ";
    get_key(root->p);
    cout << "sz = " << root->sz << endl;
}
void dfs(node *root) {
    if (!root) return;
    print(root);
    dfs(root->l);
    dfs(root->r);
}

int sz(node *root) {
    return (root ? root->sz : 0);
}

void dfs2(node *root) {
    if (!root) return;
    dfs2(root->l);
    dfs2(root->r);
    root->sz = 1 + max(sz(root->l), sz(root->r));
}

bool ans = true;

void dfs3(node *root) {
    if (!root) return;
    dfs3(root->l);
    dfs3(root->r);
    if (abs(sz(root->l) - sz(root->r)) > 1) ans = false;
}

int main() {
    inout0;
    int key;
    cin >> key;
    node *tree = new node(key);
    while (cin >> key) {
        if (key < tree->key) {
            tree->l = new node(key, tree);
            tree = tree->l;
        } else if (!tree->p || key < tree->p->key) {
            tree->r = new node(key, tree);
            tree = tree->r;
        } else {
            tree = tree->p;
            while (tree->r) tree = tree->p;
            tree->r = new node(key, tree);
            tree = tree->r;
        }
    }
    while (tree->p) tree = tree->p;
    dfs2(tree);
    dfs3(tree);
    cout << (ans ? "YES" : "NO") << endl << tree->sz << endl;
}