#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <stack>

using namespace std;

struct Proc {
	int size;
	vector <string> calls;
};

struct Call {
	string name;
	int called;
};

struct Chain {
	int size;
	vector <string> hist;
	stack <Call> calls;
};

map <string, Proc> info;
vector <Chain> ans;

int n, s;

void rec(Chain chain, int num) {
	if (chain.size < 0 || chain.size == s || chain.calls.empty())
		return;
	if (num > n)
		return;

	Call last = chain.calls.top();

	if (last.called >= info[last.name].calls.size()) {
		chain.calls.pop();
		rec(chain, num);
		return;
	}

	string call = info[last.name].calls[last.called];

	last.called++;

	vector <string> tempHist = chain.hist;
	tempHist.push_back(call);

	stack <Call> tempCalls = chain.calls;
	tempCalls.pop();
	tempCalls.push(last);
	tempCalls.push({ call, 0 });

	int sumSize = chain.size + info[call].size;
	if (sumSize > s)
		sumSize = -1;
	ans.push_back({ sumSize, tempHist, {} });

	rec({ sumSize, tempHist, tempCalls }, num + 1);
	tempCalls.pop();
	rec({ chain.size, chain.hist, tempCalls }, num);
}

int main() {
	int size = 0;
	string command, name, cur;

	cin >> n >> s >> command;
	while (command != ".") {
		if (command == "PROC") {
			cin >> name;
			if (name != "MAIN")
				cin >> size;
			cur = name;
			info[cur].size = size;
		}
		else if (command == "CALL") {
			cin >> name;
			info[cur].calls.push_back(name);
		}
		cin >> command;
	}

	stack <Call> start;
	start.push({ "MAIN", 0 });
	rec({ 0, {"MAIN"}, start}, 0);

	cout << ans.size() << "\n";
	for (auto item : ans) {
		for (int i = 1; i < item.hist.size(); i++)
			cout << item.hist[i] << " ";
		if (item.size > 0)
			cout << item.size << "\n";
		else
			cout << "OVERFLOW\n";
	}
	return 0;
}