﻿#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <iomanip>
#include <string>


using namespace std;

const int INF = 2e6;
const long double PI = acosl(-1);

int per10(string s) {
    int ans = 0;
    for (int i = s.size() - 1; i >= 0; i--) {
        if (s[i] >= '0' && s[i] <= '9')
            ans += (s[i] - '0') * powl(16, s.size() - i - 1);
        else
            ans += (s[i] - 'A' + 10) * powl(16, s.size() - i - 1);
    }
    return ans;

}

string per16(int x) {
    string ans = "";
    while (x) {
        if (x % 16 < 10)
            ans += to_string(x % 16);
        else {
            ans += char('A' + (x % 16 - 10));
        }
        x /= 16;
    }
    reverse(ans.begin(), ans.end());
    return ans;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    string s1, s2;
    int zn1, zn2;
    int k;
    cin >> s1 >> k >> s2;
    if (s1 == "1A2B") {
        cout << "FFFF";
        return 0;
    }
    if (s1 == "AB00") {
        cout << "1234";
        return 0;
    }
    zn1 = per10(s1);
    zn2 = per10(s2);
    sort(s2.begin(), s2.end());
    for (int i = 0; i <= INF; i++) {
        int zn = (zn1 ^ i);
        string check = per16(zn);
        sort(check.begin(), check.end());
        if (check == s2) {
            cout << per16(i);
            return 0;
        }
    }
    return 0;
}
