﻿#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <iomanip>
#include <string>


using namespace std;

const int INF = 1e9;
const long double PI = acosl(-1);

map<string, int> rams;
map<vector<string>, int> used;
map<string, int> cnt;
vector<string> prognames;
vector<string> ans;
int maxcnt = 0, minweight = INF;
int n, m, ram;
vector< string > otv;

bool comp(string a, string b) {
    if (rams[a] == rams[b])
        return cnt[a] > cnt[b];
    return rams[a] < rams[b];
}

void rec(int totalram, int cntt, vector<string> ans, map<string, int> used) {
    if (totalram > ram)
        return;
    if (cntt == maxcnt && minweight > totalram) {
        maxcnt = maxcnt;
        otv = ans;
        minweight = totalram;
    }
    else
        if (cntt > maxcnt) {
            maxcnt = cntt;
            otv = ans;
            minweight = totalram;
        }
    for (int i = 0; i < prognames.size(); i++) {
        auto to = prognames[i];
        if (used[to])
            continue;
        map<string, int> fused = used;
        vector<string> fans = ans;
        fans.push_back(to);
        fused[to]++;
        rec(totalram + rams[to], cntt + cnt[to], fans, fused);
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m >> ram;
    for (int i = 0; i < n; i++) {
        string s;
        int x;
        cin >> s >> x;
        rams[s] = x;
        prognames.push_back(s);
    }
    for (int i = 0; i < m; i++) {
        string s;
        getline(cin, s);
        if (s == "")
            getline(cin, s);
        vector<string> fnames;
        while (s.find(' ') != string::npos) {
            fnames.push_back(s.substr(0, s.find(' ')));
            s.erase(0, s.find(' ') + 1);
        }
        int num = stoi(s);
        for (auto i : fnames)
            cnt[i] += num;
    }
    for (int i = 0; i < prognames.size(); i++) {
        auto to = prognames[i];
        map<string, int> usd;
        usd[to] = 1;
        rec(rams[to], cnt[to], { to }, usd);
    }
    cout << otv.size() << '\n';
    for (auto i : otv) {
        cout << i << '\n';
    }
    return 0;
}
